c $Id: Wrapper.F,v 1.1 2003/10/15 17:47:52 tradke Exp $

#include "Defines.h"

c     ==================================================================
c
c     Wrapper for ADM_BSSN/Sources.F
c    
c     ==================================================================

      module ADM_BSSN_Scalars
      implicit none
      logical :: evolveLapse,evolveShift,evolveK,evolveGamma,
     +     calcAdjustment
      INTEGER :: stencilx,stencily,stencilz
      end module ADM_BSSN_Scalars


      program wrap_ADM_BSSN_Sources

      use ADM_BSSN_Scalars
      implicit none

c     ==================================================================
c     PARAMETERS YOU DONT WANT TO CHANGE
      
c     Dimensions of arrays
      INTEGER, PARAMETER :: cctk_dim = 3

c     ==================================================================
c     LOCAL VARIABLES
      
      INTEGER i,j,k,l

c     ==================================================================
c     DECLARE VARIABLES PASSED INTO CACTUS ROUTINE

      INTEGER cctk_gsh(cctk_dim),cctk_lsh(cctk_dim)
      INTEGER cctk_lbnd(cctk_dim),cctk_ubnd(cctk_dim)
      INTEGER cctk_lssh(3*cctk_dim)
      INTEGER cctk_from(cctk_dim),cctk_to(cctk_dim)
      INTEGER cctk_bbox(2*cctk_dim)
      REAL*8   cctk_delta_time, cctk_time
      REAL*8   cctk_delta_space(cctk_dim)
      REAL*8   cctk_origin_space(cctk_dim)
      INTEGER cctk_levfac(cctk_dim)
      INTEGER cctk_levoff(cctk_dim)
      INTEGER cctk_levoffdenom(cctk_dim)
      INTEGER :: cctk_timefac = 1
      INTEGER :: cctk_convlevel = 0
      INTEGER cctk_nghostzones(cctk_dim)
      INTEGER :: cctk_iteration = 1
      INTEGER local_spatial_order
      INTEGER*4 :: cctkGH = 3

      integer:: XADM_BSSN_B0 = DIMX
      integer:: XADM_BSSN_B1=DIMY
      integer:: XADM_BSSN_B2=DIMZ
      integer:: XADM_BSSN_B_prev0=DIMX
      integer:: XADM_BSSN_B_prev1=DIMY
      integer:: XADM_BSSN_B_prev2=DIMZ
      integer:: XADM_BSSN_K0=DIMX
      integer:: XADM_BSSN_K1=DIMY
      integer:: XADM_BSSN_K2=DIMZ
      integer:: XADM_BSSN_K_prev0=DIMX
      integer:: XADM_BSSN_K_prev1=DIMY
      integer:: XADM_BSSN_K_prev2=DIMZ
      integer:: XADM_BSSN_K_stag0=DIMX
      integer:: XADM_BSSN_K_stag1=DIMY
      integer:: XADM_BSSN_K_stag2=DIMZ
      integer:: XADM_BSSN_alp_prev0=DIMX
      integer:: XADM_BSSN_alp_prev1=DIMY
      integer:: XADM_BSSN_alp_prev2=DIMZ
      integer:: XADM_BSSN_beta_prev0=DIMX
      integer:: XADM_BSSN_beta_prev1=DIMY
      integer:: XADM_BSSN_beta_prev2=DIMZ
      integer:: XADM_BSSN_cons0=DIMX
      integer:: XADM_BSSN_cons1=DIMY
      integer:: XADM_BSSN_cons2=DIMZ
      integer:: XADM_BSSN_curv0=DIMX
      integer:: XADM_BSSN_curv1=DIMY
      integer:: XADM_BSSN_curv2=DIMZ
      integer:: XADM_BSSN_curv_prev0=DIMX
      integer:: XADM_BSSN_curv_prev1=DIMY
      integer:: XADM_BSSN_curv_prev2=DIMZ
      integer:: XADM_BSSN_curv_stag0=DIMX
      integer:: XADM_BSSN_curv_stag1=DIMY
      integer:: XADM_BSSN_curv_stag2=DIMZ
      integer:: XADM_BSSN_dtlapse0=DIMX
      integer:: XADM_BSSN_dtlapse1=DIMY
      integer:: XADM_BSSN_dtlapse2=DIMZ
      integer:: XADM_BSSN_dtlapse_prev0=DIMX
      integer:: XADM_BSSN_dtlapse_prev1=DIMY
      integer:: XADM_BSSN_dtlapse_prev2=DIMZ
      integer:: XADM_BSSN_extrap0=DIMX
      integer:: XADM_BSSN_extrap1=DIMY
      integer:: XADM_BSSN_extrap2=DIMZ
      integer:: XADM_BSSN_gamma0=DIMX
      integer:: XADM_BSSN_gamma1=DIMY
      integer:: XADM_BSSN_gamma2=DIMZ
      integer:: XADM_BSSN_gamma_prev0=DIMX
      integer:: XADM_BSSN_gamma_prev1=DIMY
      integer:: XADM_BSSN_gamma_prev2=DIMZ
      integer:: XADM_BSSN_initial0=DIMX
      integer:: XADM_BSSN_initial1=DIMY
      integer:: XADM_BSSN_initial2=DIMZ
      integer:: XADM_BSSN_lapse00=DIMX
      integer:: XADM_BSSN_lapse01=DIMY
      integer:: XADM_BSSN_lapse02=DIMZ
      integer:: XADM_BSSN_mask0=DIMX
      integer:: XADM_BSSN_mask1=DIMY
      integer:: XADM_BSSN_mask2=DIMZ
      integer:: XADM_BSSN_metric0=DIMX
      integer:: XADM_BSSN_metric1=DIMY
      integer:: XADM_BSSN_metric2=DIMZ
      integer:: XADM_BSSN_metric_prev0=DIMX
      integer:: XADM_BSSN_metric_prev1=DIMY
      integer:: XADM_BSSN_metric_prev2=DIMZ
      integer:: XADM_BSSN_phi0=DIMX
      integer:: XADM_BSSN_phi1=DIMY
      integer:: XADM_BSSN_phi2=DIMZ
      integer:: XADM_BSSN_phi_prev0=DIMX
      integer:: XADM_BSSN_phi_prev1=DIMY
      integer:: XADM_BSSN_phi_prev2=DIMZ
      integer:: XADM_BSSN_shift00=DIMX
      integer:: XADM_BSSN_shift01=DIMY
      integer:: XADM_BSSN_shift02=DIMZ
      integer:: XADM_BSSN_sources0=DIMX
      integer:: XADM_BSSN_sources1=DIMY
      integer:: XADM_BSSN_sources2=DIMZ
      integer:: XHISAAKI_constraints0=DIMX
      integer:: XHISAAKI_constraints1=DIMY
      integer:: XHISAAKI_constraints2=DIMZ
      integer:: XBSSN_DIVBETA0=DIMX
      integer:: XBSSN_DIVBETA1=DIMY
      integer:: XBSSN_DIVBETA2=DIMZ
      integer:: XCONSTRAINT_DMOM0=DIMX
      integer:: XCONSTRAINT_DMOM1=DIMY
      integer:: XCONSTRAINT_DMOM2=DIMZ
      integer:: XSPACE_MASK_GROUP0=DIMX
      integer:: XSPACE_MASK_GROUP1=DIMY
      integer:: XSPACE_MASK_GROUP2=DIMZ

c     Storage is assigned for all grid functions:

c     Declaring large arrays here tends to put them on the stack, which
c     is limited on some architectures.  Thus these are declared
c     "allocatable", and allocated with allocate().

      REAL*8, allocatable ::   ADM_BS_Axx(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Axy(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Axz(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Ayy(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Ayz(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Azz(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Axx_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Axy_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Axz_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Ayy_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Ayz_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Azz_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Axx_p_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Axy_p_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Axz_p_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Ayy_p_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Ayz_p_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Azz_p_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Axx_stag(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Axy_stag(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Axz_stag(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Ayy_stag(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Ayz_stag(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Azz_stag(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Bx(:,:,:)
      REAL*8, allocatable ::   ADM_BS_By(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Bz(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Bx_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_By_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Bz_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Bx_p_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_By_p_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Bz_p_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Bx0(:,:,:)
      REAL*8, allocatable ::   ADM_BS_By0(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Bz0(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Gx(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Gy(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Gz(:,:,:)

      REAL*8, allocatable ::   ADM_BS_Gx_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Gy_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Gz_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Gx_p_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Gy_p_p(:,:,:)
      REAL*8, allocatable ::   ADM_BS_Gz_p_p(:,:,:)

      REAL*8, allocatable :: ADM_BS_K(:,:,:)
      REAL*8, allocatable :: ADM_BS_K_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_K_p_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_K_stag(:,:,:)
      REAL*8, allocatable :: ADM_BS_alp0(:,:,:)
      REAL*8, allocatable :: ADM_BS_alp_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_betax0(:,:,:)
      REAL*8, allocatable :: ADM_BS_betax_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_betay0(:,:,:)
      REAL*8, allocatable :: ADM_BS_betay_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_betaz0(:,:,:)
      REAL*8, allocatable :: ADM_BS_betaz_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_dirx(:,:,:)
      REAL*8, allocatable :: ADM_BS_diry(:,:,:)
      REAL*8, allocatable :: ADM_BS_dirz(:,:,:)
      REAL*8, allocatable :: ADM_BS_dtalp(:,:,:)
      REAL*8, allocatable :: ADM_BS_dtalp0(:,:,:)
      REAL*8, allocatable :: ADM_BS_dtalp_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_dtalp_p_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_gxx(:,:,:)
      REAL*8, allocatable :: ADM_BS_gxx_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_gxx_p_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_gxy(:,:,:)
      REAL*8, allocatable :: ADM_BS_gxy_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_gxy_p_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_gxz(:,:,:)
      REAL*8, allocatable :: ADM_BS_gxz_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_gxz_p_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_gyy(:,:,:)
      REAL*8, allocatable :: ADM_BS_gyy_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_gyy_p_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_gyz(:,:,:)
      REAL*8, allocatable :: ADM_BS_gyz_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_gyz_p_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_gzz(:,:,:)
      REAL*8, allocatable :: ADM_BS_gzz_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_gzz_p_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_ham(:,:,:)
      REAL*8, allocatable :: ADM_BS_mask(:,:,:)
      REAL*8, allocatable :: ADM_BS_momx(:,:,:)
      REAL*8, allocatable :: ADM_BS_momy(:,:,:)
      REAL*8, allocatable :: ADM_BS_momz(:,:,:)
      REAL*8, allocatable :: ADM_BS_phi(:,:,:)
      REAL*8, allocatable :: ADM_BS_phi_p(:,:,:)
      REAL*8, allocatable :: ADM_BS_phi_p_p(:,:,:)
      REAL*8, allocatable :: adm_bs_Axx0(:,:,:)
      REAL*8, allocatable :: adm_bs_Axy0(:,:,:)
      REAL*8, allocatable :: adm_bs_Axz0(:,:,:)
      REAL*8, allocatable :: adm_bs_Ayy0(:,:,:)
      REAL*8, allocatable :: adm_bs_Ayz0(:,:,:)
      REAL*8, allocatable :: adm_bs_Azz0(:,:,:)
      REAL*8, allocatable :: adm_bs_Gx0(:,:,:)
      REAL*8, allocatable :: adm_bs_Gx_extrap(:,:,:)
      REAL*8, allocatable :: adm_bs_Gy0(:,:,:)
      REAL*8, allocatable :: adm_bs_Gy_extrap(:,:,:)
      REAL*8, allocatable :: adm_bs_Gz0(:,:,:)
      REAL*8, allocatable :: adm_bs_Gz_extrap(:,:,:)
      REAL*8, allocatable :: adm_bs_K0(:,:,:)
      REAL*8, allocatable :: adm_bs_alp_extrap(:,:,:)
      REAL*8, allocatable :: adm_bs_gxx0(:,:,:)
      REAL*8, allocatable :: adm_bs_gxx_extrap(:,:,:)
      REAL*8, allocatable :: adm_bs_gxy0(:,:,:)
      REAL*8, allocatable :: adm_bs_gxy_extrap(:,:,:)
      REAL*8, allocatable :: adm_bs_gxz0(:,:,:)
      REAL*8, allocatable :: adm_bs_gxz_extrap(:,:,:)
      REAL*8, allocatable :: adm_bs_gyy0(:,:,:)
      REAL*8, allocatable :: adm_bs_gyy_extrap(:,:,:)
      REAL*8, allocatable :: adm_bs_gyz0(:,:,:)
      REAL*8, allocatable :: adm_bs_gyz_extrap(:,:,:)
      REAL*8, allocatable :: adm_bs_gzz0(:,:,:)
      REAL*8, allocatable :: adm_bs_gzz_extrap(:,:,:)
      REAL*8, allocatable :: adm_bs_phi0(:,:,:)
      REAL*8, allocatable :: adm_bs_phi_extrap(:,:,:)
      REAL*8, allocatable :: adm_bs_sAxx(:,:,:)
      REAL*8, allocatable :: adm_bs_sAxy(:,:,:)
      REAL*8, allocatable :: adm_bs_sAxz(:,:,:)
      REAL*8, allocatable :: adm_bs_sAyy(:,:,:)
      REAL*8, allocatable :: adm_bs_sAyz(:,:,:)
      REAL*8, allocatable :: adm_bs_sAzz(:,:,:)
      REAL*8, allocatable :: adm_bs_sBx(:,:,:)
      REAL*8, allocatable :: adm_bs_sBy(:,:,:)
      REAL*8, allocatable :: adm_bs_sBz(:,:,:)
      REAL*8, allocatable :: adm_bs_sGx(:,:,:)
      REAL*8, allocatable :: adm_bs_sGy(:,:,:)
      REAL*8, allocatable :: adm_bs_sGz(:,:,:)
      REAL*8, allocatable :: adm_bs_sK(:,:,:)
      REAL*8, allocatable :: adm_bs_salp(:,:,:)
      REAL*8, allocatable :: adm_bs_sbetax(:,:,:)
      REAL*8, allocatable :: adm_bs_sbetay(:,:,:)
      REAL*8, allocatable :: adm_bs_sbetaz(:,:,:)
      REAL*8, allocatable :: adm_bs_sdtalp(:,:,:)
      REAL*8, allocatable :: adm_bs_sgxx(:,:,:)
      REAL*8, allocatable :: adm_bs_sgxy(:,:,:)
      REAL*8, allocatable :: adm_bs_sgxz(:,:,:)
      REAL*8, allocatable :: adm_bs_sgyy(:,:,:)
      REAL*8, allocatable :: adm_bs_sgyz(:,:,:)
      REAL*8, allocatable :: adm_bs_sgzz(:,:,:)
      REAL*8, allocatable :: adm_bs_sphi(:,:,:)

      integer :: Xconfac0=DIMX
      integer :: Xconfac1=DIMY
      integer :: Xconfac2=DIMZ
      integer :: Xconfac_1derivs0=DIMX
      integer :: Xconfac_1derivs1=DIMY
      integer :: Xconfac_1derivs2=DIMZ
      integer :: Xconfac_2derivs0=DIMX
      integer :: Xconfac_2derivs1=DIMY
      integer :: Xconfac_2derivs2=DIMZ
      integer :: Xcoordinates0=DIMX
      integer :: Xcoordinates1=DIMY
      integer :: Xcoordinates2=DIMZ
      integer :: Xcurv0=DIMX
      integer :: Xcurv1=DIMY
      integer :: Xcurv2=DIMZ
      integer :: Xlapse0=DIMX
      integer :: Xlapse1=DIMY
      integer :: Xlapse2=DIMZ
      integer :: Xmask0=DIMX
      integer :: Xmask1=DIMY
      integer :: Xmask2=DIMZ
      integer :: Xmetric0=DIMX
      integer :: Xmetric1=DIMY
      integer :: Xmetric2=DIMZ
      integer :: Xshift0=DIMX
      integer :: Xshift1=DIMY
      integer :: Xshift2=DIMZ
      integer*4 :: active_slicing_handle = 1
      REAL*8, allocatable :: alp(:,:,:)
      REAL*8, allocatable :: alp_p(:,:,:)
      REAL*8, allocatable :: alp_p_p(:,:,:)
      REAL*8, allocatable :: betax(:,:,:)
      REAL*8, allocatable :: betax_p(:,:,:)
      REAL*8, allocatable :: betax_p_p(:,:,:)
      REAL*8, allocatable :: betay(:,:,:)
      REAL*8, allocatable :: betay_p(:,:,:)
      REAL*8, allocatable :: betay_p_p(:,:,:)
      REAL*8, allocatable :: betaz(:,:,:)
      REAL*8, allocatable :: betaz_p(:,:,:)
      REAL*8, allocatable :: betaz_p_p(:,:,:)
      REAL*8, allocatable :: bssn_divbeta(:,:,:)
      REAL*8 :: coarse_dx=2.56410256410256D-002
      REAL*8 :: coarse_dy=2.56410256410256D-002
      REAL*8 :: coarse_dz=5.26315789473684D-002
      integer*4 :: conformal_state=3
      REAL*8, allocatable :: constraint_A(:,:,:)
      REAL*8, allocatable :: constraint_DMom(:,:,:)
      REAL*8, allocatable :: constraint_DMom_xx(:,:,:)
      REAL*8, allocatable :: constraint_DMom_xy(:,:,:)
      REAL*8, allocatable :: constraint_DMom_xz(:,:,:)
      REAL*8, allocatable :: constraint_DMom_yy(:,:,:)
      REAL*8, allocatable :: constraint_DMom_yz(:,:,:)
      REAL*8, allocatable :: constraint_DMom_zz(:,:,:)
      REAL*8, allocatable :: constraint_Gx(:,:,:)
      REAL*8, allocatable :: constraint_Gy(:,:,:)
      REAL*8, allocatable :: constraint_Gz(:,:,:)
      REAL*8, allocatable :: constraint_PG(:,:,:)
      REAL*8, allocatable :: constraint_S(:,:,:)
      REAL*8, allocatable :: constraint_ham(:,:,:)
      REAL*8, allocatable :: constraint_momx(:,:,:)
      REAL*8, allocatable :: constraint_momy(:,:,:)
      REAL*8, allocatable :: constraint_momz(:,:,:)
      REAL*8, allocatable :: constraint_normham(:,:,:)
      REAL*8, allocatable :: emask(:,:,:)
      REAL*8, allocatable :: gxx(:,:,:)
      REAL*8, allocatable :: gxx_p(:,:,:)
      REAL*8, allocatable :: gxx_p_p(:,:,:)
      REAL*8, allocatable :: gxy(:,:,:)
      REAL*8, allocatable :: gxy_p(:,:,:)
      REAL*8, allocatable :: gxy_p_p(:,:,:)
      REAL*8, allocatable :: gxz(:,:,:)
      REAL*8, allocatable :: gxz_p(:,:,:)
      REAL*8, allocatable :: gxz_p_p(:,:,:)
      REAL*8, allocatable :: gyy(:,:,:)
      REAL*8, allocatable :: gyy_p(:,:,:)
      REAL*8, allocatable :: gyy_p_p(:,:,:)
      REAL*8, allocatable :: gyz(:,:,:)
      REAL*8, allocatable :: gyz_p(:,:,:)
      REAL*8, allocatable :: gyz_p_p(:,:,:)
      REAL*8, allocatable :: gzz(:,:,:)
      REAL*8, allocatable :: gzz_p(:,:,:)
      REAL*8, allocatable :: gzz_p_p(:,:,:)
      REAL*8, allocatable :: kxx(:,:,:)
      REAL*8, allocatable :: kxx_p(:,:,:)
      REAL*8, allocatable :: kxx_p_p(:,:,:)
      REAL*8, allocatable :: kxy(:,:,:)
      REAL*8, allocatable :: kxy_p(:,:,:)
      REAL*8, allocatable :: kxy_p_p(:,:,:)
      REAL*8, allocatable :: kxz(:,:,:)
      REAL*8, allocatable :: kxz_p(:,:,:)
      REAL*8, allocatable :: kxz_p_p(:,:,:)
      REAL*8, allocatable :: kyy(:,:,:)
      REAL*8, allocatable :: kyy_p(:,:,:)
      REAL*8, allocatable :: kyy_p_p(:,:,:)
      REAL*8, allocatable :: kyz(:,:,:)
      REAL*8, allocatable :: kyz_p(:,:,:)
      REAL*8, allocatable :: kyz_p_p(:,:,:)
      REAL*8, allocatable :: kzz(:,:,:)
      REAL*8, allocatable :: kzz_p(:,:,:)
      REAL*8, allocatable :: kzz_p_p(:,:,:)
      REAL*8, allocatable :: psi(:,:,:)
      REAL*8, allocatable :: psix(:,:,:)
      REAL*8, allocatable :: psixx(:,:,:)
      REAL*8, allocatable :: psixy(:,:,:)
      REAL*8, allocatable :: psixz(:,:,:)
      REAL*8, allocatable :: psiy(:,:,:)
      REAL*8, allocatable :: psiyy(:,:,:)
      REAL*8, allocatable :: psiyz(:,:,:)
      REAL*8, allocatable :: psiz(:,:,:)
      REAL*8, allocatable :: psizz(:,:,:)
      REAL*8, allocatable :: r(:,:,:)
      integer*4 :: shift_state=1
      REAL*8, allocatable :: x(:,:,:)
      REAL*8, allocatable :: y(:,:,:)
      REAL*8, allocatable :: z(:,:,:)
      integer*4, allocatable :: space_mask(:,:,:)

c     COMMON BLOCKS:
      REAL*8    fisheye_scale
      integer* 4     advection
      integer* 4     bound
      INTEGER*4   BSSN_MaxNumConstrainedVars
      INTEGER*4   BSSN_MaxNumEvolvedVars
      INTEGER*4   BSSN_MaxNumSandRVars
      COMMON /adm_bssnrest/fisheye_scale,advection,bound,BSSN_MaxNumCons
     &trainedVars,BSSN_MaxNumEvolvedVars,BSSN_MaxNumSandRVars
      REAL*8    AlphaDissip
      REAL*8    AlphaDriver
      REAL*8    BetaDissip
      REAL*8    BetaDriver
      REAL*8    BetaDriverFac
      REAL*8    BetaDriverInf
      REAL*8    BetaDriverPhi
      REAL*8    BetaDriverPsi
      REAL*8    BetaDriverPunc
      REAL*8    GammaDriver
      REAL*8    Hcoeff
      REAL*8    K8
      REAL*8    Kam1
      REAL*8    Kam2
      REAL*8    Kkm
      REAL*8    Ksd
      REAL*8    LapseCoeff
      REAL*8    LapsePsiPower_cut
      REAL*8    Mcoeff
      REAL*8    ShiftGammaCoeff
      REAL*8    baumgarte_chi
      REAL*8    c_atten
      REAL*8    force_lapse_minimum
      REAL*8    gaugetest_DeltaOmega
      REAL*8    harmonic_f
      REAL*8    trAcoeff
      integer* 4     excisionType
      integer* 4     firststep
      integer* 4     icnflavour
      integer* 4     lapsesource
      integer* 4     slicingFlavour
      INTEGER*4   BetaDriverSpatial
      INTEGER*4   ICN_itnum
      INTEGER*4   LapsePhiPower
      INTEGER*4   LapsePsiPower
      INTEGER*4   RfromH
      INTEGER*4   ShiftAlpPower
      INTEGER*4   ShiftPhiPower
      INTEGER*4   ShiftPsiPower
      INTEGER*4   attenuate
      INTEGER*4   attenuate_gauge
      INTEGER*4   baumgarte_adjustment
      INTEGER*4   cartoon
      INTEGER*4   constraints
      INTEGER*4   divAfromD
      INTEGER*4   excise
      INTEGER*4   forceKzero
      INTEGER*4   force_lapse_positive
      INTEGER*4   freezeGamma
      INTEGER*4   freezeK
      INTEGER*4   gaugetest
      INTEGER*4   gaugetest_every
      INTEGER*4   hisaaki_adjustments
      INTEGER*4   keep_alp0
      INTEGER*4   resetBSSN
      INTEGER*4   resetGamma
      INTEGER*4   stencil_size
      INTEGER*4   stencil_sizex
      INTEGER*4   stencil_sizey
      INTEGER*4   stencil_sizez
      INTEGER*4   subtracttrA
      INTEGER*4   timelevels
      INTEGER*4   useAHmass
      INTEGER*4   useGamma
      COMMON /BSSN_MoLpriv/AlphaDissip,AlphaDriver,BetaDissip,BetaDriver
     &,BetaDriverFac,BetaDriverInf,BetaDriverPhi,BetaDriverPsi,BetaDrive
     &rPunc,GammaDriver,Hcoeff,K8,Kam1,Kam2,Kkm,Ksd,LapseCoeff,LapsePsiP
     &ower_cut,Mcoeff,ShiftGammaCoeff,baumgarte_chi,c_atten,force_lapse_
     &minimum,gaugetest_DeltaOmega,harmonic_f,trAcoeff,excisionType,firs
     &tstep,icnflavour,lapsesource,slicingFlavour,BetaDriverSpatial,ICN_
     &itnum,LapsePhiPower,LapsePsiPower,RfromH,ShiftAlpPower,ShiftPhiPow
     &er,ShiftPsiPower,attenuate,attenuate_gauge,baumgarte_adjustment,ca
     &rtoon,constraints,divAfromD,excise,forceKzero,force_lapse_positive
     &,freezeGamma,freezeK,gaugetest,gaugetest_every,hisaaki_adjustments
     &,keep_alp0,resetBSSN,resetGamma,stencil_size,stencil_sizex,stencil
     &_sizey,stencil_sizez,subtracttrA,timelevels,useAHmass,useGamma
      INTEGER*4   use_mask
      COMMON /SPACEMASKrest/use_mask
      INTEGER*4   CCTKH0
      INTEGER*4   CCTKH1
      INTEGER*4   CCTKH2
      INTEGER*4   CCTKH3
      INTEGER*4   CCTKH4
      INTEGER*4   CCTKH5
      INTEGER*4   CCTKH6
      INTEGER*4   CCTKH7
      INTEGER*4   CCTKH8
      INTEGER*4   CCTKH9
      INTEGER*4   CCTKH10
      INTEGER*4   MoL_Num_Constrained_Vars
      INTEGER*4   MoL_Num_Evolved_Vars
      INTEGER*4   MoL_Num_SaveAndRestore_Vars
      INTEGER*4   CCTKH11
      COMMON /METHODOFLINESrest/CCTKH0,CCTKH1,CCTKH2,CCTKH3,CCTKH4,CCTKH
     &5,CCTKH6,CCTKH7,CCTKH8,CCTKH9,CCTKH10,MoL_Num_Constrained_Vars,MoL
     &_Num_Evolved_Vars,MoL_Num_SaveAndRestore_Vars,CCTKH11
      INTEGER*4   radpower
      INTEGER*4   CCTKH12
      INTEGER*4   CCTKH13
      INTEGER*4   CCTKH14
      INTEGER*4   CCTKH15
      INTEGER*4   CCTKH16
      INTEGER*4   CCTKH17
      INTEGER*4   CCTKH18
      COMMON /BOUNDARYrest/radpower,CCTKH12,CCTKH13,CCTKH14,CCTKH15,CCTK
     &H16,CCTKH17,CCTKH18
      integer* 4     evolution_method
      integer* 4     CCTKH19
      integer* 4     CCTKH20
      integer* 4     initial_shift
      integer* 4     lapse_evolution_method
      integer* 4     metric_type
      integer* 4     shift_evolution_method
      COMMON /ADMBASErest/evolution_method,CCTKH19,CCTKH20,initial_shift
     &,lapse_evolution_method,metric_type,shift_evolution_method
      REAL*8    CCTKH21
      REAL*8    CCTKH22
      REAL*8    CCTKH23
      REAL*8    CCTKH24
      REAL*8    CCTKH33
      REAL*8    CCTKH34
      REAL*8    CCTKH35
      REAL*8    CCTKH36
      REAL*8    CCTKH37
      REAL*8    CCTKH38
      REAL*8    CCTKH39
      REAL*8    CCTKH40
      integer* 4     bitant_plane
      integer* 4     domain
      integer* 4     quadrant_direction
      integer* 4     CCTKH25
      integer* 4     CCTKH32
      INTEGER*4   CCTKH26
      INTEGER*4   CCTKH27
      INTEGER*4   CCTKH28
      INTEGER*4   CCTKH29
      INTEGER*4   CCTKH30
      INTEGER*4   CCTKH31
      COMMON /GRIDrest/CCTKH21,CCTKH22,CCTKH23,CCTKH24,CCTKH33,CCTKH34,C
     &CTKH35,CCTKH36,CCTKH37,CCTKH38,CCTKH39,CCTKH40,bitant_plane,domain
     &,quadrant_direction,CCTKH25,CCTKH32,CCTKH26,CCTKH27,CCTKH28,CCTKH2
     &9,CCTKH30,CCTKH31
      INTEGER*4   spatial_order
      COMMON /ADMMACROSrest/spatial_order


c     LOCAL VARIABLES:
      real :: dtw=3.20512820512820D-003

c     ==================================================================
c     ALLOCATE ARRAYS PASSED INTO CACTUS ROUTINE

      allocate(ADM_BS_Axx(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Axy(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Axz(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Ayy(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Ayz(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Azz(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Axx_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Axy_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Axz_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Ayy_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Ayz_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Azz_p(DIMX,DIMY,DIMZ))
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
      allocate(ADM_BS_Axx_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Axy_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Axz_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Ayy_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Ayz_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Azz_p_p(DIMX,DIMY,DIMZ))
#endif
      allocate(ADM_BS_Axx_stag(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Axy_stag(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Axz_stag(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Ayy_stag(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Ayz_stag(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Azz_stag(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Bx(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_By(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Bz(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Bx_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_By_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Bz_p(DIMX,DIMY,DIMZ))
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
      allocate(ADM_BS_Bx_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_By_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Bz_p_p(DIMX,DIMY,DIMZ))
#endif
      allocate(ADM_BS_Bx0(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_By0(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Bz0(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Gx(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Gy(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Gz(DIMX,DIMY,DIMZ))

      allocate(ADM_BS_Gx_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Gx_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Gy_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Gz_p(DIMX,DIMY,DIMZ))
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
      allocate(ADM_BS_Gy_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_Gz_p_p(DIMX,DIMY,DIMZ))
#endif

      allocate(ADM_BS_K(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_K_p(DIMX,DIMY,DIMZ))
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
      allocate(ADM_BS_K_p_p(DIMX,DIMY,DIMZ))
#endif
      allocate(ADM_BS_K_stag(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_alp0(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_alp_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_betax0(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_betax_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_betay0(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_betay_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_betaz0(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_betaz_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_dirx(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_diry(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_dirz(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_dtalp(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_dtalp0(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_dtalp_p(DIMX,DIMY,DIMZ))
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
      allocate(ADM_BS_dtalp_p_p(DIMX,DIMY,DIMZ))
#endif
      allocate(ADM_BS_gxx(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gxy(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gxz(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gyy(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gyz(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gzz(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gxx_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gxy_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gxz_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gyy_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gyz_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gzz_p(DIMX,DIMY,DIMZ))
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
      allocate(ADM_BS_gxx_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gxy_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gxz_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gyy_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gyz_p_p(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_gzz_p_p(DIMX,DIMY,DIMZ))
#endif
      allocate(ADM_BS_ham(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_mask(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_momx(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_momy(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_momz(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_phi(DIMX,DIMY,DIMZ))
      allocate(ADM_BS_phi_p(DIMX,DIMY,DIMZ))
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
      allocate(ADM_BS_phi_p_p(DIMX,DIMY,DIMZ))
#endif
      allocate(adm_bs_Axx0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_Axy0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_Axz0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_Ayy0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_Ayz0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_Azz0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_Gx0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_Gx_extrap(DIMX,DIMY,DIMZ))
      allocate(adm_bs_Gy0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_Gy_extrap(DIMX,DIMY,DIMZ))
      allocate(adm_bs_Gz0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_Gz_extrap(DIMX,DIMY,DIMZ))
      allocate(adm_bs_K0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_alp_extrap(DIMX,DIMY,DIMZ))
      allocate(adm_bs_gxx0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_gxx_extrap(DIMX,DIMY,DIMZ))
      allocate(adm_bs_gxy0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_gxy_extrap(DIMX,DIMY,DIMZ))
      allocate(adm_bs_gxz0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_gxz_extrap(DIMX,DIMY,DIMZ))
      allocate(adm_bs_gyy0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_gyy_extrap(DIMX,DIMY,DIMZ))
      allocate(adm_bs_gyz0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_gyz_extrap(DIMX,DIMY,DIMZ))
      allocate(adm_bs_gzz0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_gzz_extrap(DIMX,DIMY,DIMZ))
      allocate(adm_bs_phi0(DIMX,DIMY,DIMZ))
      allocate(adm_bs_phi_extrap(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sAxx(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sAxy(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sAxz(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sAyy(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sAyz(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sAzz(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sBx(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sBy(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sBz(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sGx(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sGy(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sGz(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sK(DIMX,DIMY,DIMZ))
      allocate(adm_bs_salp(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sbetax(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sbetay(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sbetaz(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sdtalp(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sgxx(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sgxy(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sgxz(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sgyy(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sgyz(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sgzz(DIMX,DIMY,DIMZ))
      allocate(adm_bs_sphi(DIMX,DIMY,DIMZ))

      allocate(alp(DIMX,DIMY,DIMZ))
      allocate(alp_p(DIMX,DIMY,DIMZ))
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
      allocate(alp_p_p(DIMX,DIMY,DIMZ))
#endif
      allocate(betax(DIMX,DIMY,DIMZ))
      allocate(betay(DIMX,DIMY,DIMZ))
      allocate(betaz(DIMX,DIMY,DIMZ))
      allocate(betax_p(DIMX,DIMY,DIMZ))
      allocate(betay_p(DIMX,DIMY,DIMZ))
      allocate(betaz_p(DIMX,DIMY,DIMZ))
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
      allocate(betax_p_p(DIMX,DIMY,DIMZ))
      allocate(betay_p_p(DIMX,DIMY,DIMZ))
      allocate(betaz_p_p(DIMX,DIMY,DIMZ))
#endif
      allocate(bssn_divbeta(DIMX,DIMY,DIMZ))
      allocate(constraint_A(DIMX,DIMY,DIMZ))
      allocate(constraint_DMom(DIMX,DIMY,DIMZ))
      allocate(constraint_DMom_xx(DIMX,DIMY,DIMZ))
      allocate(constraint_DMom_xy(DIMX,DIMY,DIMZ))
      allocate(constraint_DMom_xz(DIMX,DIMY,DIMZ))
      allocate(constraint_DMom_yy(DIMX,DIMY,DIMZ))
      allocate(constraint_DMom_yz(DIMX,DIMY,DIMZ))
      allocate(constraint_DMom_zz(DIMX,DIMY,DIMZ))
      allocate(constraint_Gx(DIMX,DIMY,DIMZ))
      allocate(constraint_Gy(DIMX,DIMY,DIMZ))
      allocate(constraint_Gz(DIMX,DIMY,DIMZ))
      allocate(constraint_PG(DIMX,DIMY,DIMZ))
      allocate(constraint_S(DIMX,DIMY,DIMZ))
      allocate(constraint_ham(DIMX,DIMY,DIMZ))
      allocate(constraint_momx(DIMX,DIMY,DIMZ))
      allocate(constraint_momy(DIMX,DIMY,DIMZ))
      allocate(constraint_momz(DIMX,DIMY,DIMZ))
      allocate(constraint_normham(DIMX,DIMY,DIMZ))
      allocate(emask(DIMX,DIMY,DIMZ))
      allocate(gxx(DIMX,DIMY,DIMZ))
      allocate(gxy(DIMX,DIMY,DIMZ))
      allocate(gxz(DIMX,DIMY,DIMZ))
      allocate(gyy(DIMX,DIMY,DIMZ))
      allocate(gyz(DIMX,DIMY,DIMZ))
      allocate(gzz(DIMX,DIMY,DIMZ))
      allocate(gxx_p(DIMX,DIMY,DIMZ))
      allocate(gxy_p(DIMX,DIMY,DIMZ))
      allocate(gyy_p(DIMX,DIMY,DIMZ))
      allocate(gxz_p(DIMX,DIMY,DIMZ))
      allocate(gyz_p(DIMX,DIMY,DIMZ))
      allocate(gzz_p(DIMX,DIMY,DIMZ))
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
      allocate(gxx_p_p(DIMX,DIMY,DIMZ))
      allocate(gxy_p_p(DIMX,DIMY,DIMZ))
      allocate(gxz_p_p(DIMX,DIMY,DIMZ))
      allocate(gyy_p_p(DIMX,DIMY,DIMZ))
      allocate(gyz_p_p(DIMX,DIMY,DIMZ))
      allocate(gzz_p_p(DIMX,DIMY,DIMZ))
#endif
      allocate(kxx(DIMX,DIMY,DIMZ))
      allocate(kxy(DIMX,DIMY,DIMZ))
      allocate(kxz(DIMX,DIMY,DIMZ))
      allocate(kyy(DIMX,DIMY,DIMZ))
      allocate(kyz(DIMX,DIMY,DIMZ))
      allocate(kzz(DIMX,DIMY,DIMZ))
      allocate(kxx_p(DIMX,DIMY,DIMZ))
      allocate(kxy_p(DIMX,DIMY,DIMZ))
      allocate(kxz_p(DIMX,DIMY,DIMZ))
      allocate(kyy_p(DIMX,DIMY,DIMZ))
      allocate(kyz_p(DIMX,DIMY,DIMZ))
      allocate(kzz_p(DIMX,DIMY,DIMZ))
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
      allocate(kxx_p_p(DIMX,DIMY,DIMZ))
      allocate(kxy_p_p(DIMX,DIMY,DIMZ))
      allocate(kxz_p_p(DIMX,DIMY,DIMZ))
      allocate(kyy_p_p(DIMX,DIMY,DIMZ))
      allocate(kyz_p_p(DIMX,DIMY,DIMZ))
      allocate(kzz_p_p(DIMX,DIMY,DIMZ))
#endif
      allocate(psi(DIMX,DIMY,DIMZ))
      allocate(psix(DIMX,DIMY,DIMZ))
      allocate(psixx(DIMX,DIMY,DIMZ))
      allocate(psixy(DIMX,DIMY,DIMZ))
      allocate(psixz(DIMX,DIMY,DIMZ))
      allocate(psiy(DIMX,DIMY,DIMZ))
      allocate(psiyy(DIMX,DIMY,DIMZ))
      allocate(psiyz(DIMX,DIMY,DIMZ))
      allocate(psiz(DIMX,DIMY,DIMZ))
      allocate(psizz(DIMX,DIMY,DIMZ))
      allocate(r(DIMX,DIMY,DIMZ))
      allocate(x(DIMX,DIMY,DIMZ))
      allocate(y(DIMX,DIMY,DIMZ))
      allocate(z(DIMX,DIMY,DIMZ))
      allocate(space_mask(DIMX,DIMY,DIMZ))


c     ==================================================================
c     FAKE INITIAL VALUES OF PASSED IN VARIABLES

      print *, "startup"
 
c     start with module ADM_BSSN_Scalars
      evolveLapse = .true.
      evolveShift = .true.
      evolveK = .true.
      evolveGamma = .true.
      calcAdjustment = .false.
      stencilx = 1
      stencily = 1
      stencilz = 1

c     now do the rest of the variables
      cctk_delta_time=3.20512820512820D-003

      cctk_lsh(1) = DIMX
      cctk_lsh(2) = DIMY
      cctk_lsh(3) = DIMZ
      
      cctk_delta_space(1) = 2.56410256410256D-002
      cctk_delta_space(2) = 2.56410256410256D-002
      cctk_delta_space(3) = 5.26315789473684D-002

      cctk_levfac(1) = 1
      cctk_levfac(2) = 1
      cctk_levfac(3) = 1
 
      do k=1,DIMZ
         do j=1,DIMY
            do i=1,DIMX
               ADM_BS_Axx(i,j,k) = 0.0
               ADM_BS_Axy(i,j,k) = 0.0
               ADM_BS_Axz(i,j,k) = 0.0
               ADM_BS_Ayy(i,j,k) = 0.0
               ADM_BS_Ayz(i,j,k) = 0.0
               ADM_BS_Azz(i,j,k) = 0.0
               ADM_BS_Axx_p(i,j,k) = 0.0
               ADM_BS_Axy_p(i,j,k) = 0.0
               ADM_BS_Axz_p(i,j,k) = 0.0
               ADM_BS_Ayy_p(i,j,k) = 0.0
               ADM_BS_Ayz_p(i,j,k) = 0.0
               ADM_BS_Azz_p(i,j,k) = 0.0
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
               ADM_BS_Axx_p_p(i,j,k) = 0.0
               ADM_BS_Axy_p_p(i,j,k) = 0.0
               ADM_BS_Axz_p_p(i,j,k) = 0.0
               ADM_BS_Ayy_p_p(i,j,k) = 0.0
               ADM_BS_Ayz_p_p(i,j,k) = 0.0
               ADM_BS_Azz_p_p(i,j,k) = 0.0
#endif
               ADM_BS_Axx_stag(i,j,k) = 0.0
               ADM_BS_Axy_stag(i,j,k) = 0.0
               ADM_BS_Axz_stag(i,j,k) = 0.0
               ADM_BS_Ayy_stag(i,j,k) = 0.0
               ADM_BS_Ayz_stag(i,j,k) = 0.0
               ADM_BS_Azz_stag(i,j,k) = 0.0
               ADM_BS_Bx(i,j,k) = 0.0
               ADM_BS_By(i,j,k) = 0.0
               ADM_BS_Bz(i,j,k) = 0.0
               ADM_BS_Bx_p(i,j,k) = 0.0
               ADM_BS_By_p(i,j,k) = 0.0
               ADM_BS_Bz_p(i,j,k) = 0.0
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
               ADM_BS_Bx_p_p(i,j,k) = 0.0
               ADM_BS_By_p_p(i,j,k) = 0.0
               ADM_BS_Bz_p_p(i,j,k) = 0.0
#endif
               ADM_BS_Bx0(i,j,k) = 0.0
               ADM_BS_By0(i,j,k) = 0.0
               ADM_BS_Bz0(i,j,k) = 0.0
               ADM_BS_Gx(i,j,k) = 0.0
               ADM_BS_Gy(i,j,k) = 0.0
               ADM_BS_Gz(i,j,k) = 0.0
               ADM_BS_Gx_p(i,j,k) = 0.0
               ADM_BS_Gy_p(i,j,k) = 0.0
               ADM_BS_Gz_p(i,j,k) = 0.0
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
               ADM_BS_Gx_p_p(i,j,k) = 0.0
               ADM_BS_Gy_p_p(i,j,k) = 0.0
               ADM_BS_Gz_p_p(i,j,k) = 0.0
#endif
               ADM_BS_K(i,j,k) = 0.0
               ADM_BS_K_p(i,j,k) = 0.0
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
               ADM_BS_K_p_p(i,j,k) = 0.0
#endif
               ADM_BS_K_stag(i,j,k) = 0.0
               ADM_BS_alp0(i,j,k) = 1.0
               ADM_BS_alp_p(i,j,k) = 1.0
               ADM_BS_betax0(i,j,k) = 0.0
               ADM_BS_betax_p(i,j,k) = 0.0
               ADM_BS_betay0(i,j,k) = 0.0
               ADM_BS_betay_p(i,j,k) = 0.0
               ADM_BS_betaz0(i,j,k) = 0.0
               ADM_BS_betaz_p(i,j,k) = 0.0
               ADM_BS_dirx(i,j,k) = 0.0
               ADM_BS_diry(i,j,k) = 0.0
               ADM_BS_dirz(i,j,k) = 0.0
               ADM_BS_dtalp(i,j,k) = 1.0
               ADM_BS_dtalp0(i,j,k) = 1.0
               ADM_BS_dtalp_p(i,j,k) = 1.0
#if 0
               ADM_BS_dtalp_p_p(i,j,k) = 1.0
#endif
               ADM_BS_gxx(i,j,k) = 1.0
               ADM_BS_gxy(i,j,k) = 0
               ADM_BS_gxz(i,j,k) = 0
               ADM_BS_gyy(i,j,k) = 1.0
               ADM_BS_gyz(i,j,k) = 0
               ADM_BS_gzz(i,j,k) = 1.0
               ADM_BS_gxx_p(i,j,k) = 1.0
               ADM_BS_gxy_p(i,j,k) = 0
               ADM_BS_gxz_p(i,j,k) = 0
               ADM_BS_gyy_p(i,j,k) = 1.0
               ADM_BS_gyz_p(i,j,k) = 0
               ADM_BS_gzz_p(i,j,k) = 1.0
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
               ADM_BS_gxx_p_p(i,j,k) = 1.0
               ADM_BS_gxy_p_p(i,j,k) = 0
               ADM_BS_gxz_p_p(i,j,k) = 0
               ADM_BS_gyy_p_p(i,j,k) = 1.0
               ADM_BS_gyz_p_p(i,j,k) = 0
               ADM_BS_gzz_p_p(i,j,k) = 1.0
#endif
               ADM_BS_ham(i,j,k) = 0.0
               ADM_BS_mask(i,j,k) = 1.0

               ADM_BS_momx(i,j,k) = 0.0
               ADM_BS_momy(i,j,k) = 0.0
               ADM_BS_momz(i,j,k) = 0.0
               ADM_BS_phi(i,j,k) = 0.0
               ADM_BS_phi_p(i,j,k) = 0.0
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
               ADM_BS_phi_p_p(i,j,k) = 0.0
#endif
               adm_bs_Axx0(i,j,k) = 0.0
               adm_bs_Axy0(i,j,k) = 0.0
               adm_bs_Axz0(i,j,k) = 0.0
               adm_bs_Ayy0(i,j,k) = 0.0
               adm_bs_Ayz0(i,j,k) = 0.0
               adm_bs_Azz0(i,j,k) = 0.0

               adm_bs_Gx0(i,j,k) = 0.0
               adm_bs_Gx_extrap(i,j,k) = 0.0
               adm_bs_Gy0(i,j,k) = 0.0
               adm_bs_Gy_extrap(i,j,k) = 0.0
               adm_bs_Gz0(i,j,k) = 0.0
               adm_bs_Gz_extrap(i,j,k) = 0.0
               adm_bs_K0(i,j,k) = 0.0
               adm_bs_alp_extrap(i,j,k) = 0.0
               adm_bs_gxx0(i,j,k) = 0.0
               adm_bs_gxx_extrap(i,j,k) = 0.0
               adm_bs_gxy0(i,j,k) = 0.0
               adm_bs_gxy_extrap(i,j,k) = 0.0
               adm_bs_gxz0(i,j,k) = 0.0
               adm_bs_gxz_extrap(i,j,k) = 0.0
               adm_bs_gyy0(i,j,k) = 0.0
               adm_bs_gyy_extrap(i,j,k) = 0.0
               adm_bs_gyz0(i,j,k) = 0.0
               adm_bs_gyz_extrap(i,j,k) = 0.0
               adm_bs_gzz0(i,j,k) = 0.0
               adm_bs_gzz_extrap(i,j,k) = 0.0
               adm_bs_phi0(i,j,k) = 0.0
               adm_bs_phi_extrap(i,j,k) = 0.0
               adm_bs_sAxx(i,j,k) = 0.0
               adm_bs_sAxy(i,j,k) = 0.0
               adm_bs_sAxz(i,j,k) = 0.0
               adm_bs_sAyy(i,j,k) = 0.0
               adm_bs_sAyz(i,j,k) = 0.0
               adm_bs_sAzz(i,j,k) = 0.0
               adm_bs_sBx(i,j,k) = 0.0
               adm_bs_sBy(i,j,k) = 0.0
               adm_bs_sBz(i,j,k) = 0.0
               adm_bs_sGx(i,j,k) = 0.0
               adm_bs_sGy(i,j,k) = 0.0
               adm_bs_sGz(i,j,k) = 0.0
               adm_bs_sK(i,j,k) = 0.0

               adm_bs_salp(i,j,k) = 0.0
               adm_bs_sbetax(i,j,k) = 0.0
               adm_bs_sbetay(i,j,k) = 0.0
               adm_bs_sbetaz(i,j,k) = 0.0
               adm_bs_sdtalp(i,j,k) = 0.0
               adm_bs_sgxx(i,j,k) = 0.0
               adm_bs_sgxy(i,j,k) = 0.0
               adm_bs_sgxz(i,j,k) = 0.0
               adm_bs_sgyy(i,j,k) = 0.0
               adm_bs_sgyz(i,j,k) = 0.0
               adm_bs_sgzz(i,j,k) = 0.0
               adm_bs_sphi(i,j,k) = 0.0
               alp(i,j,k) = 1.0
               alp_p(i,j,k) = 1.0
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
               alp_p_p(i,j,k) = 1.0
#endif
               betax(i,j,k) = 0.0
               betay(i,j,k) = 0.0
               betaz(i,j,k) = 0.0
               betax_p(i,j,k) = 0.0
               betay_p(i,j,k) = 0.0
               betaz_p(i,j,k) = 0.0
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
               betax_p_p(i,j,k) = 0.0
               betay_p_p(i,j,k) = 0.0
               betaz_p_p(i,j,k) = 0.0
#endif
               bssn_divbeta(i,j,k) = 0.0
               constraint_A(i,j,k) = 0.0
               constraint_DMom(i,j,k) = 0.0
               constraint_DMom_xx(i,j,k) = 0.0
               constraint_DMom_xy(i,j,k) = 0.0
               constraint_DMom_xz(i,j,k) = 0.0
               constraint_DMom_yy(i,j,k) = 0.0
               constraint_DMom_yz(i,j,k) = 0.0
               constraint_DMom_zz(i,j,k) = 0.0
               constraint_Gx(i,j,k) = 0.0
               constraint_Gy(i,j,k) = 0.0
               constraint_Gz(i,j,k) = 0.0
               constraint_PG(i,j,k) = 0.0
               constraint_S(i,j,k) = 0.0
               constraint_ham(i,j,k) = 0.0
               constraint_momx(i,j,k) = 0.0
               constraint_momy(i,j,k) = 0.0
               constraint_momz(i,j,k) = 0.0
               constraint_normham(i,j,k) = 0.0
               emask(i,j,k) = 0.0
               gxx(i,j,k) = 1.0
               gxy(i,j,k) = 0.0
               gxz(i,j,k) = 0.0
               gyy(i,j,k) = 1.0
               gyz(i,j,k) = 0.0
               gzz(i,j,k) = 1.0
               gxx_p(i,j,k) = 1.0
               gxy_p(i,j,k) = 0.0
               gxz_p(i,j,k) = 0.0
               gyy_p(i,j,k) = 1.0
               gyz_p(i,j,k) = 0.0
               gzz_p(i,j,k) = 1.0
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
               gxx_p_p(i,j,k) = 1.0
               gxy_p_p(i,j,k) = 0.0
               gxz_p_p(i,j,k) = 0.0
               gyy_p_p(i,j,k) = 1.0
               gyz_p_p(i,j,k) = 0.0
               gzz_p_p(i,j,k) = 1.0
#endif
               kxx(i,j,k) = 0.0
               kxy(i,j,k) = 0.0
               kxz(i,j,k) = 0.0
               kyy(i,j,k) = 0.0
               kyz(i,j,k) = 0.0
               kzz(i,j,k) = 0.0
               kxx_p(i,j,k) = 0.0
               kxy_p(i,j,k) = 0.0
               kxz_p(i,j,k) = 0.0
               kyy_p(i,j,k) = 0.0
               kyz_p(i,j,k) = 0.0
               kzz_p(i,j,k) = 0.0
#ifdef WITH_PREVIOUS_PREVIOUS_TIMELEVEL
               kxx_p_p(i,j,k) = 0.0
               kxy_p_p(i,j,k) = 0.0
               kxz_p_p(i,j,k) = 0.0
               kyy_p_p(i,j,k) = 0.0
               kyz_p_p(i,j,k) = 0.0
               kzz_p_p(i,j,k) = 0.0
#endif

               psi(i,j,k) = 1.0
               psix(i,j,k) = 0.0
               psixx(i,j,k) = 0.0
               psixy(i,j,k) = 0.0
               psixz(i,j,k) = 0.0
               psiy(i,j,k) = 0.0
               psiyy(i,j,k) = 0.0
               psiyz(i,j,k) = 0.0
               psiz(i,j,k) = 0.0
               psizz(i,j,k) = 0.0

               space_mask(i,j,k) = 0

               r(i,j,k) = i*i+j*j+k+k
               x(i,j,k) = i
               y(i,j,k) = j
               z(i,j,k) = k
            enddo
         enddo
      enddo

c     INITIALIZE COMMON BLOCKS:
      fisheye_scale = 1.
      advection = 135652648
      bound =  1096073204

      AlphaDissip = 0.
      AlphaDriver = 0.
      BetaDissip = 0.
      BetaDriver = 2.
      BetaDriverPhi = 0.
      BetaDriverPsi = 0.
      GammaDriver = 0.
      Hcoeff = 0.
      LapsePsiPower_cut = 1.
      Mcoeff = 1.
      ShiftGammaCoeff = .75
      c_atten = 1.
      gaugetest_DeltaOmega = 0.
      harmonic_f = 2.
      trAcoeff = 0.
      excisionType = 1099128824
      firststep = 1099292664
      lapsesource = 1100357620
      slicingFlavour = 1100677112

      ICN_itnum = 3
      LapsePhiPower = 0
      LapsePsiPower = 0
      RfromH = 1
      ShiftAlpPower = 1
      ShiftPhiPower = 0
      ShiftPsiPower = 4
      attenuate = 0 ! do not attenuate source terms
      attenuate_gauge = 0 ! do not attenuate gauge either
      cartoon = 0
      constraints = 0
      divAfromD = 1
      excise = 0
      forceKzero = 0
      freezeGamma = 0
      freezeK = 0
      gaugetest = 0
      gaugetest_every = 1
      keep_alp0 = 0
      resetBSSN = 0
      resetGamma = 0
      stencil_size = 2
      stencil_sizex = 1
      stencil_sizey = 1
      stencil_sizez = 1
      subtracttrA = 1
      timelevels = 2
      useAHmass = 0
      useGamma = 1
      
      radpower = 2
      
      use_mask = 0

      bitant_plane = 1092149244
      domain = 1092370424
      quadrant_direction = 1093025788
      
      advection = 1086865400
      initial_shift = 1087770616
      use_mask = 0

      evolution_method = 135649336
      lapse_evolution_method = 135648056
      metric_type = 135755224
      shift_evolution_method = 135648504

      spatial_order = 2

	write(*,*) "starting loop"

c     ==================================================================
c     CALL CACTUS ROUTINE

      do l=1,NITERATIONS
         if (mod(l,OUTEVERY).eq.0) then
            write(*,*) 'iteration=',l
c            print *, sum(ADM_BS_gyy)
         end if

         call ADM_BSSN_Sources(cctk_dim, cctk_gsh, cctk_lsh, cctk_lbn
     &d, cctk_ubnd, cctk_lssh, cctk_from, cctk_to, cctk_bbox, cctk_delta
     &_time, cctk_time, cctk_delta_space, cctk_origin_space, cctk_levfac
     &, cctk_levoff, cctk_levoffdenom, cctk_timefac, cctk_convlevel, cct
     &k_nghostzones, cctk_iteration, cctkGH , XADM_BSSN_B0,XADM_BSSN_B1,
     &XADM_BSSN_B2,XADM_BSSN_K0,XADM_BSSN_K1,XADM_BSSN_K2,XADM_BSSN_cons
     &0,XADM_BSSN_cons1,XADM_BSSN_cons2,XADM_BSSN_curv0,XADM_BSSN_curv1,
     &XADM_BSSN_curv2,XADM_BSSN_dtlapse0,XADM_BSSN_dtlapse1,XADM_BSSN_dt
     &lapse2,XADM_BSSN_gamma0,XADM_BSSN_gamma1,XADM_BSSN_gamma2,XADM_BSS
     &N_initial0,XADM_BSSN_initial1,XADM_BSSN_initial2,XADM_BSSN_lapse00
     &,XADM_BSSN_lapse01,XADM_BSSN_lapse02,XADM_BSSN_mask0,XADM_BSSN_mas
     &k1,XADM_BSSN_mask2,XADM_BSSN_metric0,XADM_BSSN_metric1,XADM_BSSN_m
     &etric2,XADM_BSSN_phi0,XADM_BSSN_phi1,XADM_BSSN_phi2,XADM_BSSN_shif
     &t00,XADM_BSSN_shift01,XADM_BSSN_shift02,XADM_BSSN_sources0,XADM_BS
     &SN_sources1,XADM_BSSN_sources2,XHISAAKI_constraints0,XHISAAKI_cons
     &traints1,XHISAAKI_constraints2,Xbssn_divbeta0,Xbssn_divbeta1,Xbssn
     &_divbeta2,Xconfac0,Xconfac1,Xconfac2,Xconfac_1derivs0,Xconfac_1der
     &ivs1,Xconfac_1derivs2,Xconfac_2derivs0,Xconfac_2derivs1,Xconfac_2d
     &erivs2,Xconstraint_DMom0,Xconstraint_DMom1,Xconstraint_DMom2,Xcoor
     &dinates0,Xcoordinates1,Xcoordinates2,Xcurv0,Xcurv1,Xcurv2,Xlapse0,
     &Xlapse1,Xlapse2,Xmask0,Xmask1,Xmask2,Xmetric0,Xmetric1,Xmetric2,Xs
     &hift0,Xshift1,Xshift2,Xspace_mask_group0,Xspace_mask_group1,Xspace
     &_mask_group2,ADM_BS_Axx,ADM_BS_Axx_p,ADM_BS_Axx_p_p,ADM_BS_Axy,ADM
     &_BS_Axy_p,ADM_BS_Axy_p_p,ADM_BS_Axz,ADM_BS_Axz_p,ADM_BS_Axz_p_p,AD
     &M_BS_Ayy,ADM_BS_Ayy_p,ADM_BS_Ayy_p_p,ADM_BS_Ayz,ADM_BS_Ayz_p,ADM_B
     &S_Ayz_p_p,ADM_BS_Azz,ADM_BS_Azz_p,ADM_BS_Azz_p_p,ADM_BS_Bx,ADM_BS_
     &Bx_p,ADM_BS_Bx_p_p,ADM_BS_Bx0,ADM_BS_By,ADM_BS_By_p,ADM_BS_By_p_p,
     &ADM_BS_By0,ADM_BS_Bz,ADM_BS_Bz_p,ADM_BS_Bz_p_p,ADM_BS_Bz0,ADM_BS_G
     &x,ADM_BS_Gx_p,ADM_BS_Gx_p_p,ADM_BS_Gy,ADM_BS_Gy_p,ADM_BS_Gy_p_p,AD
     &M_BS_Gz,ADM_BS_Gz_p,ADM_BS_Gz_p_p,ADM_BS_K,ADM_BS_K_p,ADM_BS_K_p_p
     &,ADM_BS_alp0,ADM_BS_betax0,ADM_BS_betay0,ADM_BS_betaz0,ADM_BS_dirx
     &,ADM_BS_diry,ADM_BS_dirz,ADM_BS_dtalp,ADM_BS_dtalp_p,ADM_BS_dtalp_
     &p_p,ADM_BS_dtalp0,ADM_BS_gxx,ADM_BS_gxx_p,ADM_BS_gxx_p_p,ADM_BS_gx
     &y,ADM_BS_gxy_p,ADM_BS_gxy_p_p,ADM_BS_gxz,ADM_BS_gxz_p,ADM_BS_gxz_p
     &_p,ADM_BS_gyy,ADM_BS_gyy_p,ADM_BS_gyy_p_p,ADM_BS_gyz,ADM_BS_gyz_p,
     &ADM_BS_gyz_p_p,ADM_BS_gzz,ADM_BS_gzz_p,ADM_BS_gzz_p_p,ADM_BS_ham,A
     &DM_BS_mask,ADM_BS_momx,ADM_BS_momy,ADM_BS_momz,ADM_BS_phi,ADM_BS_p
     &hi_p,ADM_BS_phi_p_p,active_slicing_handle,adm_bs_Axx0,adm_bs_Axy0,
     &adm_bs_Axz0,adm_bs_Ayy0,adm_bs_Ayz0,adm_bs_Azz0,adm_bs_Gx0,adm_bs_
     &Gy0,adm_bs_Gz0,adm_bs_K0,adm_bs_gxx0,adm_bs_gxy0,adm_bs_gxz0,adm_b
     &s_gyy0,adm_bs_gyz0,adm_bs_gzz0,adm_bs_phi0,adm_bs_sAxx,adm_bs_sAxy
     &,adm_bs_sAxz,adm_bs_sAyy,adm_bs_sAyz,adm_bs_sAzz,adm_bs_sBx,adm_bs
     &_sBy,adm_bs_sBz,adm_bs_sGx,adm_bs_sGy,adm_bs_sGz,adm_bs_sK,adm_bs_
     &salp,adm_bs_sbetax,adm_bs_sbetay,adm_bs_sbetaz,adm_bs_sdtalp,adm_b
     &s_sgxx,adm_bs_sgxy,adm_bs_sgxz,adm_bs_sgyy,adm_bs_sgyz,adm_bs_sgzz
     &,adm_bs_sphi,alp,alp_p,alp_p_p,betax,betax_p,betax_p_p,betay,betay
     &_p,betay_p_p,betaz,betaz_p,betaz_p_p,bssn_divbeta,coarse_dx,coarse
     &_dy,coarse_dz,conformal_state,constraint_A,constraint_DMom,constra
     &int_DMom_xx,constraint_DMom_xy,constraint_DMom_xz,constraint_DMom_
     &yy,constraint_DMom_yz,constraint_DMom_zz,constraint_Gx,constraint_
     &Gy,constraint_Gz,constraint_PG,constraint_S,constraint_ham,constra
     &int_momx,constraint_momy,constraint_momz,constraint_normham,emask,
     &gxx,gxx_p,gxx_p_p,gxy,gxy_p,gxy_p_p,gxz,gxz_p,gxz_p_p,gyy,gyy_p,gy
     &y_p_p,gyz,gyz_p,gyz_p_p,gzz,gzz_p,gzz_p_p,kxx,kxx_p,kxx_p_p,kxy,kx
     &y_p,kxy_p_p,kxz,kxz_p,kxz_p_p,kyy,kyy_p,kyy_p_p,kyz,kyz_p,kyz_p_p,
     &kzz,kzz_p,kzz_p_p,local_spatial_order,psi,psix,psixx,psixy,psixz,p
     &siy,psiyy,psiyz,psiz,psizz,r,shift_state,space_mask,x,y,z    )

c     UPDATE STUFF
         do k=1,DIMZ
            do j=1,DIMY
               do i=1,DIMX
                  ADM_BS_alp_p(i,j,k) = alp(i,j,k)
                  ADM_BS_dtalp_p(i,j,k) = ADM_BS_dtalp(i,j,k)
                  ADM_BS_betax_p(i,j,k) = betax(i,j,k)
                  ADM_BS_betay_p(i,j,k) = betay(i,j,k)
                  ADM_BS_betaz_p(i,j,k) = betaz(i,j,k)
                  ADM_BS_Bx_p(i,j,k) = ADM_BS_Bx(i,j,k)
                  ADM_BS_By_p(i,j,k) = ADM_BS_By(i,j,k)
                  ADM_BS_Bz_p(i,j,k) = ADM_BS_Bz(i,j,k)
                  ADM_BS_phi_p(i,j,k) = ADM_BS_phi(i,j,k)
                  ADM_BS_gxx_p(i,j,k) = ADM_BS_gxx(i,j,k)
                  ADM_BS_gxy_p(i,j,k) = ADM_BS_gxy(i,j,k)
                  ADM_BS_gxz_p(i,j,k) = ADM_BS_gxz(i,j,k)
                  ADM_BS_gyy_p(i,j,k) = ADM_BS_gyy(i,j,k)
                  ADM_BS_gyz_p(i,j,k) = ADM_BS_gyz(i,j,k)
                  ADM_BS_gzz_p(i,j,k) = ADM_BS_gzz(i,j,k)
                  ADM_BS_K_p(i,j,k) = ADM_BS_K(i,j,k)
                  ADM_BS_Axx_p(i,j,k) = ADM_BS_Axx(i,j,k)
                  ADM_BS_Axy_p(i,j,k) = ADM_BS_Axy(i,j,k)
                  ADM_BS_Axz_p(i,j,k) = ADM_BS_Axz(i,j,k)
                  ADM_BS_Ayy_p(i,j,k) = ADM_BS_Ayy(i,j,k)
                  ADM_BS_Ayz_p(i,j,k) = ADM_BS_Ayz(i,j,k)
                  ADM_BS_Azz_p(i,j,k) = ADM_BS_Azz(i,j,k)
                  ADM_BS_Gx_p(i,j,k) = ADM_BS_Gx(i,j,k)
                  ADM_BS_Gy_p(i,j,k) = ADM_BS_Gy(i,j,k)
                  ADM_BS_Gz_p(i,j,k) = ADM_BS_Gz(i,j,k)

                  betax(i,j,k) = ADM_BS_betax_p(i,j,k)
     .                 + dtw*adm_bs_sbetax(i,j,k)
                  betay(i,j,k) = ADM_BS_betay_p(i,j,k)
     .                 + dtw*adm_bs_sbetay(i,j,k)
                  betaz(i,j,k) = ADM_BS_betaz_p(i,j,k)
     .                 + dtw*adm_bs_sbetaz(i,j,k)
               end do
            end do
         end do

         do k=1+1,DIMZ-1
            do j=1+1,DIMY-1
               do i=1+1,DIMX-1
                  ADM_BS_Bx(i,j,k) = ADM_BS_Bx_p(i,j,k)
     .                 + dtw*adm_bs_sBx(i,j,k)
                  ADM_BS_By(i,j,k) = ADM_BS_By_p(i,j,k)
     .                 + dtw*adm_bs_sBy(i,j,k)
                  ADM_BS_Bz(i,j,k) = ADM_BS_Bz_p(i,j,k)
     .                 + dtw*adm_bs_sBz(i,j,k)

                  ADM_BS_phi(i,j,k) = ADM_BS_phi_p(i,j,k)
     .                 + dtw*adm_bs_sphi(i,j,k)
                  ADM_BS_gxx(i,j,k) = ADM_BS_gxx_p(i,j,k)
     .                 + dtw*adm_bs_sgxx(i,j,k)
                  ADM_BS_gyy(i,j,k) = ADM_BS_gyy_p(i,j,k)
     .                 + dtw*adm_bs_sgyy(i,j,k)
                  ADM_BS_gzz(i,j,k) = ADM_BS_gzz_p(i,j,k)
     .                 + dtw*adm_bs_sgzz(i,j,k)
                  ADM_BS_gxy(i,j,k) = ADM_BS_gxy_p(i,j,k)
     .                 + dtw*adm_bs_sgxy(i,j,k)
                  ADM_BS_gxz(i,j,k) = ADM_BS_gxz_p(i,j,k)
     .                 + dtw*adm_bs_sgxz(i,j,k)
                  ADM_BS_gyz(i,j,k) = ADM_BS_gyz_p(i,j,k)
     .                 + dtw*adm_bs_sgyz(i,j,k)

                  ADM_BS_K(i,j,k) = ADM_BS_K_p(i,j,k)
     .                 + dtw*adm_bs_sK(i,j,k)

                  ADM_BS_Axx(i,j,k) = ADM_BS_Axx_p(i,j,k)
     .                 + dtw*adm_bs_sAxx(i,j,k)
                  ADM_BS_Ayy(i,j,k) = ADM_BS_Ayy_p(i,j,k)
     .                 + dtw*adm_bs_sAyy(i,j,k)
                  ADM_BS_Azz(i,j,k) = ADM_BS_Azz_p(i,j,k)
     .                 + dtw*adm_bs_sAzz(i,j,k)
                  ADM_BS_Axy(i,j,k) = ADM_BS_Axy_p(i,j,k)
     .                 + dtw*adm_bs_sAxy(i,j,k)
                  ADM_BS_Axz(i,j,k) = ADM_BS_Axz_p(i,j,k)
     .                 + dtw*adm_bs_sAxz(i,j,k)
                  ADM_BS_Ayz(i,j,k) = ADM_BS_Ayz_p(i,j,k)
     .                 + dtw*adm_bs_sAyz(i,j,k)

                  ADM_BS_Gx(i,j,k) = ADM_BS_Gx_p(i,j,k)
     .                 + dtw*adm_bs_sGx(i,j,k)
                  ADM_BS_Gy(i,j,k) = ADM_BS_Gy_p(i,j,k)
     .                 + dtw*adm_bs_sGy(i,j,k)
                  ADM_BS_Gz(i,j,k) = ADM_BS_Gz_p(i,j,k)
     .                 + dtw*adm_bs_sGz(i,j,k)
               end do
            end do
         end do

      enddo

c     ==================================================================
c     CHECK RESULTS

      print *,"done"
      print *,"Value after",NITERATIONS,"iterations with",DIMX,"x",
     .DIMY,"x",DIMZ
      print *,"       should be:   1.00000000000000"
      print *,"             Got:",sum(ADM_BS_gyy)/
     &     real(cctk_lsh(1)*cctk_lsh(2)*cctk_lsh(3))

      end

c     ==================================================================
c     DUMMY FUNCTIONS

      integer function CCTK_Equals(a,b)
      implicit none

         INTEGER*4 a
         character(len=10) b

         CCTK_Equals = 2

c         if (a.eq.1) CCTK_EQUALS = 1 ! always return yes if first arg is 1

         if (b(1:4) .eq. "none") CCTK_Equals = 0
         if (b(1:6) .eq. "center") CCTK_Equals = 0
         if (b(1:6) .eq. "upwind") CCTK_Equals = 1
         if (b(1:6) .eq. "simple") CCTK_Equals = 0

         if (CCTK_Equals .eq. 2) then 
            print *, "error in CCTK_Equals"
            print *, "a=",a
            print *, "b=",b
         endif

      end function CCTK_Equals

      subroutine CCTK_IsThornActive
c     This subroutine contains no executable code
      end subroutine CCTK_IsThornActive

      subroutine CCTK_MyProc
c     This subroutine contains no executable code
      end subroutine CCTK_MyProc

      subroutine CCTK_nProcs
c     This subroutine contains no executable code
      end subroutine CCTK_nProcs

      subroutine CCTK_NullPointer
c     This subroutine contains no executable code
      end subroutine CCTK_NullPointer

      subroutine CCTK_PointerTo
c     This subroutine contains no executable code
      end subroutine CCTK_PointerTo

      subroutine CCTK_SyncGroup
c     This subroutine contains no executable code
      end subroutine CCTK_SyncGroup

      subroutine CartSymGN
c     This subroutine contains no executable code
      end subroutine CartSymGN

      subroutine ADM_BSSN_LapseSource
c     This subroutine contains no executable code
      end subroutine ADM_BSSN_LapseSource

      subroutine ADM_BSSN_ShiftSource
c     This subroutine contains no executable code
      end subroutine ADM_BSSN_ShiftSource

      subroutine ADM_BSSN_AttenuateGauge
c     This subroutine contains no executable code
      end subroutine ADM_BSSN_AttenuateGauge

      subroutine ADM_BSSN_AttenuateSource
c     This subroutine contains no executable code
      end subroutine ADM_BSSN_AttenuateSource

      subroutine ADM_BSSN_BigMask
c     This subroutine contains no executable code
      end subroutine ADM_BSSN_BigMask
